local maplaps = 4
local processed = false
local timer = 3*TICRATE
local jingleheadertoggle = true
local finishplayed = false

addHook("MapLoad", do
	if multiplayer
		if mapheaderinfo[gamemap].numlaps
			maplaps = mapheaderinfo[gamemap].numlaps
		else
			maplaps = 4
		end
		processed = false
		timer = 3*TICRATE
		jingleheadertoggle = true
		finishplayed = false
	end
end)

addHook("ThinkFrame", do
	if multiplayer
		if (gametype == GT_RACE)
			if circuitmap
				for player in players.iterate()
					if (player and player.mo and player.mo.valid)
						if (processed == false and 1+player.laps == maplaps)
							if jingleheadertoggle
								chatprint("\x82* "..player.name.."\x80 entered the\x85 final lap\x80!")
								S_StartMusicCaption("Final lap!", 3*TICRATE, player)
								S_ChangeMusic("FINLAP", false, player)
								jingleheadertoggle = false
							end
							if timer == 0
								P_RestoreMusic(player)
								processed = true
							end
							timer = timer - 1
						elseif (processed and finishplayed == false)
							S_SetMusicPosition(S_GetMusicPosition() + 5)
						end
						if (player.exiting ~= 0 and finishplayed == false)
							S_StartSound(nil, sfx_finish, player)
							S_ChangeMusic("_INTER", true, player)
							finishplayed = true
						end
					end
				end
			end
		end
	end
end)